#ifndef __PENDULUM_H
#define __PENDULUM_H
#include "soleng.h"
#define NPoint 100
class Struna : public SceneObject{
public:
	Struna();
	void draw();	
	void doStep();
	void keyboard(int key);
	bool getCastsShadows() const {return true;}
private:
	// struna
	void solveAnalitic(float  dt);
	void solveEuler(float  dt);
private:
	CTexture txt;
	Vector3d r;
	char info[1024];
	float ox[10];
	float oy[10];
	
	int counter;
	int motion_blur;
	GLUquadric *c1;
	Graph2D *gr;
	
	int solver;		// 0 - euler. 1 - midpoint. 2 - RK4
	int drawvector;
	double g;
	
	
	//Struna
	float Amp[NPoint];  // wartoci stablicowane 
	float Vel[NPoint];  // wartoci stablicowane 
	float A[10];		// amplitudy kolejnych skadowych
	float Fi[10];		// Przesunicia ktowe skadowych 
	float t;			// czas
	float L;		// dugo struny
	float V;			// prdko rozchodzenia ski fali
	float Ek;			// energia kinetyczna
	float Ep;			// energia potcjalna
	float Ro;			// liniowa gsto masy struny	
	float T0;			// sia nacigu		
	float dt;
};

#endif

